import { jsx as n, jsxs as y, Fragment as U } from "react/jsx-runtime";
import o from "clsx";
import E, { lazy as A, useRef as z, useEffect as O, Suspense as j } from "react";
/*!
  @versini/ui-panel v1.2.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PANEL__ || (window.__VERSINI_UI_PANEL__ = {
    version: "1.2.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const M = "av-messagebox", C = "av-panel", R = "av-button";
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const G = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, T = "icon", W = "button", D = "link", H = ({
  type: e,
  size: r,
  labelRight: t,
  labelLeft: a,
  align: d
}) => {
  const l = "text-sm font-medium max-h-8 py-0", g = "text-base font-medium max-h-9 py-1", i = "text-lg font-medium max-h-12 py-2";
  switch (e) {
    case W:
      return o("px-4", {
        [l]: r === "small",
        [g]: r === "medium",
        [i]: r === "large"
      });
    case D:
      return o("px-4 text-center", {
        [l]: r === "small",
        [g]: r === "medium",
        [i]: r === "large"
      });
    case T:
      return o("inline-flex items-center", {
        "justify-center": d === "center",
        "justify-start": d === "left",
        "justify-end": d === "right",
        "h-6 w-6 p-0": r === "small" && !(t || a),
        "h-6 px-4 text-sm font-medium": r === "small" && (t || a),
        "h-8 w-8 p-1": r === "medium" && !(t || a),
        "h-8 px-4 text-base font-medium": r === "medium" && (t || a),
        "h-12 w-12 p-2": r === "large" && !(t || a),
        "h-12 px-4 text-lg font-medium": r === "large" && (t || a)
      });
  }
}, X = ({
  mode: e,
  noBackground: r,
  noTruncate: t,
  variant: a
}) => {
  if (r)
    return "not-prose rounded-full";
  if (a === "primary")
    return o("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "dark",
      "bg-action-light text-copy-lighter": e === "light",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "alt-system"
    });
  if (a === "secondary")
    return o("not-prose rounded-full", {
      truncate: !t,
      "bg-action-dark text-copy-light": e === "light",
      "bg-action-light text-copy-lighter": e === "dark",
      "bg-action-dark text-copy-light dark:bg-action-light dark:text-copy-lighter": e === "alt-system",
      "bg-action-light text-copy-lighter dark:bg-action-dark dark:text-copy-light": e === "system"
    });
  if (a === "danger")
    return o("not-prose rounded-full", {
      truncate: !t,
      "bg-action-danger-dark text-copy-light": e === "dark",
      "bg-action-danger-light text-copy-lighter": e === "light",
      "bg-action-danger-dark text-copy-light dark:bg-action-danger-light dark:text-copy-lighter": e === "system",
      "bg-action-danger-light text-copy-lighter dark:bg-action-danger-dark dark:text-copy-light": e === "alt-system"
    });
}, Y = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "dark",
      "hover:bg-action-light-hover": e === "light",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "alt-system"
    });
  if (t === "secondary")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-dark-hover": e === "light",
      "hover:bg-action-light-hover": e === "dark",
      "hover:bg-action-dark-hover dark:hover:bg-action-light-hover": e === "alt-system",
      "hover:bg-action-light-hover dark:hover:bg-action-dark-hover": e === "system"
    });
  if (t === "danger")
    return o("hover:text-copy-light-hover", {
      "hover:bg-action-danger-dark-hover": e === "dark",
      "hover:bg-action-danger-light-hover": e === "light",
      "hover:bg-action-danger-dark-hover dark:hover:bg-action-danger-light-hover": e === "system",
      "hover:bg-action-danger-light-hover dark:hover:bg-action-danger-dark-hover": e === "alt-system"
    });
}, F = ({
  mode: e,
  disabled: r,
  variant: t
}) => {
  if (r)
    return "";
  if (t === "primary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "dark",
      "active:bg-action-light-active": e === "light",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "alt-system"
    });
  if (t === "secondary")
    return o("active:text-copy-light-active", {
      "active:bg-action-dark-active": e === "light",
      "active:bg-action-light-active": e === "dark",
      "active:bg-action-dark-active dark:active:bg-action-light-active": e === "alt-system",
      "active:bg-action-light-active dark:active:bg-action-dark-active": e === "system"
    });
  if (t === "danger")
    return o("active:text-copy-lighter-active", {
      "active:bg-action-danger-dark-active": e === "dark",
      "active:bg-action-danger-light-active": e === "light",
      "active:bg-action-danger-dark-active dark:active:bg-action-danger-light-active": e === "system",
      "active:bg-action-danger-light-active dark:active:bg-action-danger-dark-active": e === "alt-system"
    });
}, q = ({
  mode: e,
  noBorder: r,
  variant: t
}) => {
  if (r)
    return "border border-transparent";
  if (t === "primary")
    return o("border", {
      "border-border-dark": e === "dark",
      "border-border-accent": e === "light",
      "border-border-dark dark:border-border-accent": e === "system",
      "border-border-accent dark:border-border-dark": e === "alt-system"
    });
  if (t === "secondary")
    return o("border", {
      "border-border-dark": e === "light",
      "border-border-accent": e === "dark",
      "border-border-dark dark:border-border-accent": e === "alt-system",
      "border-border-accent dark:border-border-dark": e === "system"
    });
  if (t === "danger")
    return o("border", {
      "border-border-danger-dark": e === "dark",
      "border-border-danger-medium": e === "light",
      "border-border-danger-dark dark:border-border-danger-medium": e === "system",
      "border-border-danger-medium dark:border-border-danger-dark": e === "alt-system"
    });
}, J = ({ focusMode: e }) => o("focus:outline", "focus:outline-2", "focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), $ = ({
  type: e,
  className: r,
  raw: t,
  mode: a,
  focusMode: d,
  disabled: l,
  fullWidth: g,
  size: i,
  noBorder: h,
  labelRight: s,
  labelLeft: u,
  spacing: b,
  noBackground: m,
  variant: c,
  noTruncate: v,
  align: f
}) => (c || (c = "primary"), t ? o(R, r) : o(
  R,
  r,
  G(b),
  X({ mode: a, variant: c, noBackground: m, noTruncate: v }),
  H({ type: e, size: i, labelRight: s, labelLeft: u, align: f }),
  q({ mode: a, variant: c, noBorder: h }),
  J({ focusMode: d }),
  Y({ mode: a, variant: c, disabled: l }),
  F({ mode: a, variant: c, disabled: l }),
  {
    "w-full": g,
    "disabled:cursor-not-allowed disabled:opacity-50": l
  }
)), K = (e, r, t) => {
  var a;
  !r && (!document.activeElement || document.activeElement !== e.currentTarget) && typeof ((a = e == null ? void 0 : e.currentTarget) == null ? void 0 : a.focus) == "function" && e.currentTarget.focus(), typeof t == "function" && t(e);
}, B = E.forwardRef((e, r) => {
  const { onClick: t, noInternalClick: a = !1, ...d } = e;
  return /* @__PURE__ */ n(
    "button",
    {
      ref: r,
      onClick: (l) => {
        K(l, a, t);
      },
      ...d
    }
  );
});
B.displayName = "BaseButton";
const L = E.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: d = !1,
    className: l,
    type: g = "button",
    raw: i = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: u,
    size: b = "medium",
    labelRight: m,
    labelLeft: c,
    spacing: v,
    noBackground: f = !1,
    align: _ = "center",
    ...w
  }, N) => {
    const I = $({
      type: T,
      mode: t,
      focusMode: a,
      fullWidth: d,
      disabled: r,
      raw: i,
      className: l,
      noBorder: h,
      size: b,
      labelRight: m,
      labelLeft: c,
      spacing: v,
      noBackground: f,
      align: _
    }), S = o({
      "text-copy-accent-dark": t === "light" && !i,
      "text-copy-light": t === "dark" && !i,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !i,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !i
    });
    return /* @__PURE__ */ y(
      B,
      {
        ref: N,
        className: I,
        disabled: r,
        type: g,
        "aria-label": s || u,
        ...w,
        children: [
          c && /* @__PURE__ */ n("span", { className: "pr-2", children: c }),
          /* @__PURE__ */ n("div", { className: S, children: e }),
          m && /* @__PURE__ */ n("span", { className: "pl-2", children: m })
        ]
      }
    );
  }
);
L.displayName = "ButtonIcon";
/*!
  @versini/ui-button v1.4.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_BUTTON__ || (window.__VERSINI_UI_BUTTON__ = {
    version: "1.4.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Q = E.forwardRef(
  ({
    children: e,
    disabled: r = !1,
    mode: t = "system",
    focusMode: a = "system",
    fullWidth: d = !1,
    className: l,
    type: g = "button",
    raw: i = !1,
    noBorder: h = !1,
    "aria-label": s,
    label: u,
    size: b = "medium",
    labelRight: m,
    labelLeft: c,
    spacing: v,
    noBackground: f = !1,
    align: _ = "center",
    active: w = !1,
    ...N
  }, I) => {
    const S = $({
      type: T,
      mode: t,
      focusMode: a,
      fullWidth: d,
      disabled: r,
      raw: i,
      className: l,
      noBorder: h,
      size: b,
      labelRight: m,
      labelLeft: c,
      spacing: v,
      noBackground: f,
      align: _
    }), P = o({
      "text-copy-accent-dark": t === "light" && !i,
      "text-copy-light": t === "dark" && !i,
      "text-copy-accent-dark dark:text-copy-light": t === "alt-system" && !i,
      "text-copy-light dark:text-copy-accent-dark": t === "system" && !i
    }), V = w ? o(
      "relative",
      "focus-within:static",
      "focus-within:after:border-transparent",
      "after:absolute",
      "after:content-['']",
      "after:border-b-2",
      "after:bottom-[-4px]",
      "after:left-0",
      "after:right-0",
      {
        "after:border-table-dark": t === "dark",
        "after:border-table-light": t === "light",
        "after:border-table-dark dark:after:border-table-light": t === "system",
        "after:border-table-light dark:after:border-table-dark": t === "alt-system"
      }
    ) : "";
    return /* @__PURE__ */ n("div", { className: V, children: /* @__PURE__ */ y(
      B,
      {
        ref: I,
        className: S,
        disabled: r,
        type: g,
        "aria-label": s || u,
        ...N,
        children: [
          c && /* @__PURE__ */ n("span", { className: "pr-2", children: c }),
          /* @__PURE__ */ n("div", { className: P, children: e }),
          m && /* @__PURE__ */ n("span", { className: "pl-2", children: m })
        ]
      }
    ) });
  }
);
Q.displayName = "ButtonSort";
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Z = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, ee = ({
  children: e,
  fill: r,
  viewBox: t,
  className: a,
  defaultViewBox: d,
  defaultClassName: l,
  spacing: g,
  title: i,
  semantic: h = !1,
  ...s
}) => {
  const u = Z(g), b = o(
    u,
    a || l
  );
  return /* @__PURE__ */ y(U, { children: [
    /* @__PURE__ */ n(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: b,
        viewBox: t || d,
        fill: r || "currentColor",
        role: "img",
        "aria-hidden": !h,
        focusable: !1,
        ...s,
        children: e
      }
    ),
    i && h && /* @__PURE__ */ n("span", { className: "sr-only", children: i })
  ] });
};
/*!
  @versini/ui-svgicon v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SVGICON__ || (window.__VERSINI_UI_SVGICON__ = {
    version: "1.0.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const te = ({
  className: e,
  viewBox: r,
  spacing: t,
  title: a,
  monotone: d,
  ...l
}) => /* @__PURE__ */ n(
  ee,
  {
    defaultViewBox: "0 0 384 512",
    defaultClassName: "size-5",
    viewBox: r,
    className: e,
    spacing: t,
    title: a || "Close",
    ...l,
    children: /* @__PURE__ */ n("path", { d: "M342.6 150.6c12.5-12.5 12.5-32.8 0-45.3s-32.8-12.5-45.3 0L192 210.7 86.6 105.4c-12.5-12.5-32.8-12.5-45.3 0s-12.5 32.8 0 45.3L146.7 256 41.4 361.4c-12.5 12.5-12.5 32.8 0 45.3s32.8 12.5 45.3 0L192 301.3l105.4 105.3c12.5 12.5 32.8 12.5 45.3 0s12.5-32.8 0-45.3L237.3 256l105.3-105.4z" })
  }
);
/*!
  @versini/ui-icons v1.18.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_ICONS__ || (window.__VERSINI_UI_ICONS__ = {
    version: "1.18.0",
    buildTime: "12/25/2024 03:12 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const p = "panel", x = "messagebox", re = ({
  className: e,
  kind: r,
  borderMode: t
}) => ({
  main: o("prose prose-lighter flex flex-col bg-surface-medium", {
    [`${C} max-h-full sm:max-h-[95%] min-h-full sm:min-h-[10rem] sm:rounded-lg sm:border-2`]: r === p,
    [`${C} w-full sm:w-[95%] md:max-w-2xl`]: r === p && !e,
    [`${M} rounded-lg border-2`]: r === x,
    [`${M} w-[95%] sm:w-[50%] md:max-w-2xl`]: r === x && !e,
    [`${e}`]: !!e,
    "sm:border-border-dark": t === "dark" && r === p,
    "sm:border-border-accent": t === "light" && r === p,
    "border-border-dark": t === "dark" && r === x,
    "border-border-accent": t === "light" && r === x
  }),
  content: "flex flex-col py-2 sm:py-4 sm:px-4 px-2 overflow-y-auto",
  footer: "flex flex-grow flex-col sm:p-4 p-2",
  header: "sm:p-4 mb-0 p-2",
  close: "sm:p-4 p-2"
}), k = (e) => A(
  () => import("./chunks/index.B81Wx2iM.js").then((r) => ({
    default: r[e]
  }))
), ae = k("Modal"), oe = k("ModalClose"), ie = k("ModalContent"), ne = k("ModalDescription"), le = k("ModalHeading"), ge = ({
  open: e,
  onOpenChange: r,
  title: t,
  children: a,
  footer: d,
  borderMode: l = "light",
  kind: g = p,
  className: i
}) => {
  const h = z(""), s = re({ className: i, kind: g, borderMode: l });
  return O(() => (e && (h.current = document.title, document.title = `${t} | ${h.current}`), () => {
    e && (document.title = h.current);
  }), [t, e]), /* @__PURE__ */ n(j, { fallback: /* @__PURE__ */ n("div", {}), children: e && /* @__PURE__ */ n(ae, { open: e, onOpenChange: r, children: /* @__PURE__ */ y(ie, { className: s.main, children: [
    /* @__PURE__ */ y("div", { className: "flex flex-row-reverse items-center justify-between", children: [
      /* @__PURE__ */ n(
        oe,
        {
          className: s.close,
          trigger: /* @__PURE__ */ n(
            L,
            {
              mode: "dark",
              focusMode: "light",
              noBorder: !0,
              label: "Close",
              children: /* @__PURE__ */ n(te, {})
            }
          )
        }
      ),
      /* @__PURE__ */ n(le, { className: s.header, children: t })
    ] }),
    /* @__PURE__ */ n(ne, { className: s.content, children: a }),
    d && /* @__PURE__ */ n("div", { className: s.footer, children: d })
  ] }) }) });
};
export {
  M as MESSAGEBOX_CLASSNAME,
  C as PANEL_CLASSNAME,
  ge as Panel
};
